unit Form_Main;

{===============================================================================
ATTENTION NECESSITE LES COMPOSANTS INDY version 9 
Utilisation d'un composant IdHTTP pour tlcharger un fichier
  - Authentification (login, mot de passe)
  - Progression tlchargement

Le composant IdAntiFreeze permet de ne pas figer l'application
lors du tlchargement (<- cette solution est prfrable)
sinon il faut crire "Application.ProcessMessage"  l'endroit indiqu (dans le code)
Pour plus de dtail voir l'aide sur "IdAntiFreeze"
--------------------------------------------------------------------------------
DEBOVE Benjamin
08/03/2004
b_debove@hotmail.com

--------------------------------------------------------------------------------
Composants Indy, site officiel ==> http://www.indyproject.org
Comment l'installer            ==> http://delphipage.free.fr/indy.html
Exemple ralis  partir de    ==> http://www.remixtech.com/tutidhttpe.php

===============================================================================}

{------------------------------------------------------------------------------}
                                   INTERFACE                                    
{------------------------------------------------------------------------------}
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, IdAntiFreezeBase, IdBaseComponent,
  IdComponent, IdTCPConnection, IdTCPClient, IdHTTP, ExtCtrls, Spin,
  ComCtrls, IdAntiFreeze;

type
  TFormMain = class(TForm)
    IdHTTP: TIdHTTP;
    StatusBarConnexion: TStatusBar;
    PanelConnexion: TPanel;
    ButtonDeconnexion: TButton;
    ButtonConnexion: TButton;
    SpinEditPort: TSpinEdit;
    LabelPort: TLabel;
    PanelDownload: TPanel;
    ProgressBarDownload: TProgressBar;
    LabelTailleTelecharge: TLabel;
    ButtonEvaluerTaille: TButton;
    ButtonTelecharger: TButton;
    SpinEditTaille: TSpinEdit;
    LabelTaille: TLabel;
    IdAntiFreeze: TIdAntiFreeze;
    EditLogin: TEdit;
    EditPassword: TEdit;
    EditHost: TEdit;
    LabelPassword: TLabel;
    LabelLogin: TLabel;
    LabelHost: TLabel;
    EditSource: TEdit;
    LabelSource: TLabel;
    EditDestination: TEdit;
    LabelDestination: TLabel;
    LabelOctet: TLabel;
    procedure ButtonTelechargerClick(Sender: TObject);
    procedure ButtonConnexionClick(Sender: TObject);
    procedure ButtonDeconnexionClick(Sender: TObject);
    procedure ButtonEvaluerTailleClick(Sender: TObject);
  //EVENT IDHTTP
    procedure IdHTTPWork(Sender: TObject; AWorkMode: TWorkMode;
                                      const AWorkCount: Integer);
    procedure IdHTTPWorkBegin(Sender: TObject; AWorkMode: TWorkMode;
                                      const AWorkCountMax: Integer);
    procedure IdHTTPWorkEnd(Sender: TObject; AWorkMode: TWorkMode);
    procedure IdHTTPStatus(axSender: TObject; const axStatus: TIdStatus;
                                      const asStatusText: String);
    procedure IdHTTPConnected(Sender: TObject);
    procedure IdHTTPDisconnected(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
  public
  end;

var
  FormMain: TFormMain;

Const
  RS_Fin = 'Tlchargement termin';
  RS_Debit = '%d / %d';
{------------------------------------------------------------------------------}
                                 IMPLEMENTATION
{------------------------------------------------------------------------------}

{$R *.dfm}
{----------------------------------FORM-CLOSE----------------------------------}
procedure TFormMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  ButtonDeconnexionClick(nil); //On s'assure d'tre dconnect
end;                                                     
{==============================================================================}
{====================================BUTTON====================================}
{==============================================================================}
{----------------------------BUTTON-CONNEXION-CLICK----------------------------}
procedure TFormMain.ButtonConnexionClick(Sender: TObject);
begin
  IdHTTP.Host             := EditHost.Text;      //Adresse du site web
  IdHTTP.port             := SpinEditPort.Value; //Numro de port utilis
  IdHTTP.Request.Username := EditLogin.Text;     //Login
  IdHTTP.Request.Password := EditPassword.Text; //Mot de passe
  if IdHTTP.Connected then IdHTTP.Disconnect;
  try
    IdHTTP.Connect;
  except
  end;
end;
{---------------------------BUTTON-DECONNEXION-CLICK---------------------------}
procedure TFormMain.ButtonDeconnexionClick(Sender: TObject);
begin
  IdHTTP.Disconnect;
end;                   
{-------------------------BUTTON-EVALUER-TAILLE-CLICK--------------------------}
procedure TFormMain.ButtonEvaluerTailleClick(Sender: TObject);
begin
  if IdHTTP.Connected then
  begin
    IdHTTP.Head(EditSource.Text); //On rcupre l'entte du fichier  tlcharger
    SpinEditTaille.Value := IdHTTP.Response.ContentLength; //On affiche sa taille
  end
  else SpinEditTaille.Value := 0;
end;
{---------------------------BUTTON-TELECHARGER-CLICK---------------------------}
procedure TFormMain.ButtonTelechargerClick(Sender: TObject);
var TmpFileStream : TFileStream;
begin
  ButtonEvaluerTailleClick(nil);//On affiche la taille du fichier  tlcharger
  try
    //On cre un fichier
    TmpFileStream := TFileStream.Create(EditDestination.Text, fmCreate);
    //On enregistre les donnes tlcharges dans ce fichier
    IdHTTP.Get(EditSource.Text, TmpFileStream);
  finally
    FreeAndNil(TmpFileStream);
  end;
end;                  
{==============================================================================}
{-------------------------------ID-HTTP-CONNECTED------------------------------}
procedure TFormMain.IdHTTPConnected(Sender: TObject);
begin
  PanelDownload.Color := clSkyBlue;
  PanelDownload.Enabled := IdHTTP.Connected;
end;
{-----------------------------ID-HTTP-DISCONNECTED-----------------------------}
procedure TFormMain.IdHTTPDisconnected(Sender: TObject);
begin
  PanelDownload.Color := clBtnFace;
  PanelDownload.Enabled := IdHTTP.Connected;
end;
{---------------------------------ID-HTTP-STATUS-------------------------------}
procedure TFormMain.IdHTTPStatus(axSender: TObject; const axStatus: TIdStatus;
                                   const asStatusText: String);
//Etat de la connexion
begin
  StatusBarConnexion.Panels[0].Text := asStatusText;
end;
{==============================================================================}
{=============================BARRE=DE=PROGRESSION=============================} 
{==============================================================================}
{-------------------------------ID-HTTP-WORK-BEGIN-----------------------------}
//Dbut du tlchargement
procedure TFormMain.IdHTTPWorkBegin(Sender: TObject; AWorkMode: TWorkMode;
                                         const AWorkCountMax: Integer);
begin
  if AWorkMode = wmRead then
  begin
    ProgressBarDownload.Max := AWorkCountMax;
    ProgressBarDownload.Position := 0 ;
  end;
end;
{----------------------------------ID-HTTP-WORK--------------------------------}
//Tlchargement
procedure TFormMain.IdHTTPWork(Sender: TObject; AWorkMode: TWorkMode;
                                          const AWorkCount: Integer);
begin
  if AWorkMode = wmRead then
  begin
    ProgressBarDownload.Position := AWorkCount ;
    LabelTailleTelecharge.Caption :=
                         Format(RS_Debit, [AWorkCount, ProgressBarDownload.Max]);
    //Application.ProcessMessage; //-->  activez cette ligne si vous n'utilisez
    //pas le composant IdAntiFreeze (afin de ne pas figer l'application)
    //Sleep(10);  //-->  activez cette ligne pour ralentir le tlchargement
  end;
end;
{--------------------------------ID-HTTP-WORK-END------------------------------}
procedure TFormMain.IdHTTPWorkEnd(Sender: TObject; AWorkMode: TWorkMode);
//Fin du tlchargement
begin
  if AWorkMode = wmRead then
  begin
    LabelTailleTelecharge.Caption := RS_Fin;
    ProgressBarDownload.Position := ProgressBarDownload.Max;
  end;
end;


end.
